{
*****************************************************************************
*  Name    : NETTypes.BAS                                                   *
*  Date    : 28/08/2007                                                     *
*  Version : 1.0 - Based around Microchip TCP/IP stack version 4.13         *
*  Notes   :                                                                *
* ========================================================================= *
* Software License Agreement                                                *
*                                                                           *
* Copyright  2002-2007 Microchip Technology Inc.  All rights reserved.     *
*                                                                           *
* Microchip licenses To you the right To use, modify, copy, And distribute: *
* (i)  the Software when embedded on a Microchip microcontroller Or digital *
*      signal controller product (Device) which is integrated into        *
*      Licensees product; Or                                               *
* (ii) ONLY the Software driver source files ENC28J60.c And ENC28J60.h      *
*      ported To a non-Microchip Device used in conjunction With a          *
*      Microchip ethernet controller For the sole purpose of interfacing    *
*      With the ethernet controller.                                        *
*                                                                           *
* You should refer To the license agreement accompanying this Software For  *
* additional information regarding your rights And obligations.             *
*                                                                           *
* THE SOFTWARE And DOCUMENTATION ARE PROVIDED As IS WITHOUT WARRANTY OF   *
* ANY KIND, EITHER EXPRESS Or IMPLIED, INCLUDING WITHOUT LIMITATION, ANY    *
* WARRANTY OF MERCHANTABILITY, FITNESS For A PARTICULAR PURPOSE, TITLE And  *
* NON-INFRINGEMENT. IN NO Event SHALL MICROCHIP BE LIABLE For ANY           *
* INCIDENTAL, SPECIAL, INDIRECT Or CONSEQUENTIAL DAMAGES, LOST PROFITS Or   *
* LOST DATA, COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY Or         *
* SERVICES, ANY CLAIMS BY THIRD PARTIES (INCLUDING BUT Not LIMITED To ANY   *
* DEFENSE THEREOF), ANY CLAIMS For INDEMNITY Or CONTRIBUTION, Or OTHER      *
* SIMILAR COSTS, WHETHER ASSERTED ON THE BASIS OF CONTRACT, TORT (INCLUDING *
* NEGLIGENCE), BREACH OF WARRANTY, Or OTHERWISE.                            *
*****************************************************************************
}
Module NETTypes

(*
*****************************************************************************
* GenericTypeDefs.h
*****************************************************************************
*)
Public Type
   DWORD = LongWord,         // 32 bit unsigned
   SHORT = Integer,          // 16 bit signed
   LONG = LongInt            // 32 bit signed

// byte val...
Public Structure BYTE_VAL
   Val As Byte
   b0 As Val.0
   b1 As Val.1
   b2 As Val.2
   b3 As Val.3
   b4 As Val.4
   b5 As Val.5
   b6 As Val.6
   b7 As Val.7
End Structure

Structure TWordBits
   b0 As Bit
   b1 As Bit
   b2 As Bit
   b3 As Bit
   b4 As Bit
   b5 As Bit
   b6 As Bit
   b7 As Bit
   b8 As Bit
   b9 As Bit
   b10 As Bit
   b11 As Bit
   b12 As Bit
   b13 As Bit
   b14 As Bit
   b15 As Bit
End Structure   

Structure TWordBytes
   LB As Byte
   HB As Byte
End Structure
   
// word val...
Public Structure WORD_VAL
   Val As Word
   v(2) As Byte Union
   Bytes As TWordBytes Union
   Bits As TWordBits Union
End Structure

Structure TDWORDWords
   LW As Word
   HW As Word
End Structure

Structure TDWORDBytes
   LB As Byte
   HB As Byte
   UB As Byte
   MB As Byte
End Structure   

Structure TDWORDBits
   b0 As Bit
   b1 As Bit
   b2 As Bit
   b3 As Bit
   b4 As Bit
   b5 As Bit
   b6 As Bit
   b7 As Bit
   b8 As Bit
   b9 As Bit
   b10 As Bit
   b11 As Bit
   b12 As Bit
   b13 As Bit
   b14 As Bit
   b15 As Bit
   b16 As Bit
   b17 As Bit
   b18 As Bit
   b19 As Bit
   b20 As Bit
   b21 As Bit
   b22 As Bit
   b23 As Bit
   b24 As Bit
   b25 As Bit
   b26 As Bit
   b27 As Bit
   b28 As Bit
   b29 As Bit
   b30 As Bit
   b31 As Bit   
End Structure
 
// dword val...  
Public Structure DWORD_VAL
   Val As DWORD
   w(2) As Word Union
   v(4) As Byte Union
   Words As TDWORDWords Union
   Bytes As TDWORDBytes Union
   Bits As TDWORDBits Union
End Structure
(*
*****************************************************************************
* StackTsk.h
*****************************************************************************
*)
Public Type 
   IP_ADDR = DWORD_VAL

Public Structure MAC_ADDR
   v(6) As Byte
End Structure

Public Structure NODE_INFO
   MACAddr As MAC_ADDR
   IPAddr As IP_ADDR
End Structure

Structure TAppFlags
   Val As Byte
   bIsDHCPEnabled As Val.Booleans(6)
   bInConfigMode As Val.Booleans(7)
End Structure

Structure APP_CONFIG
   MyIPAddr As IP_ADDR
   MyMask As IP_ADDR
   MyGateway As IP_ADDR
   PrimaryDNSServer As IP_ADDR
   SecondaryDNSServer As IP_ADDR
   DefaultIPAddr As IP_ADDR
   DefaultMask As IP_ADDR
   MyMACAddr As MAC_ADDR
   NetBIOSName(16) As Byte
   Flags As TAppFlags
End Structure

Public Dim
   AppConfig As APP_CONFIG,  // global app config 
   remoteNode As NODE_INFO   // initialised in stack task, also used elsewhere
                             // for example, NBNS





    


