{
*****************************************************************************
*  Name    : NETUtils.BAS                                                   *
*  Date    : 30/08/2007                                                     *
*  Version : 1.0 - Based around Microchip TCP/IP stack version 4.11         *
*  Notes   :                                                                *
* ========================================================================= *
* Software License Agreement                                                *
*                                                                           *
* Copyright  2002-2007 Microchip Technology Inc.  All rights reserved.     *
*                                                                           *
* Microchip licenses to you the right to use, modify, copy, and distribute: *
* (i)  the Software when embedded on a Microchip microcontroller or digital *
*      signal controller product (Device) which is integrated into        *
*      Licensees product; or                                               *
* (ii) ONLY the Software driver source files ENC28J60.c and ENC28J60.h      *
*      ported to a non-Microchip device used in conjunction with a          *
*      Microchip ethernet controller for the sole purpose of interfacing    *
*      with the ethernet controller.                                        *
*                                                                           *
* You should refer to the license agreement accompanying this Software for  *
* additional information regarding your rights and obligations.             *
*                                                                           *
* THE SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY OF   *
* ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY    *
* WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND  *
* NON-INFRINGEMENT. IN NO EVENT SHALL MICROCHIP BE LIABLE FOR ANY           *
* INCIDENTAL, SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR   *
* LOST DATA, COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR         *
* SERVICES, ANY CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY   *
* DEFENSE THEREOF), ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER      *
* SIMILAR COSTS, WHETHER ASSERTED ON THE BASIS OF CONTRACT, TORT (INCLUDING *
* NEGLIGENCE), BREACH OF WARRANTY, OR OTHERWISE.                            *
*****************************************************************************
}
Module NETUtils

Public Type TROMAddress = Word
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Inline Sub Reset()
   ASM
   Reset
   End ASM
End Sub 
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Inline Function ReadRAM(pAddress As FSR0) As INDF0
End Function
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Function ReadROM(pAddress As TROMAddress) As TABLAT
//   TBLPTRU = pAddress.Byte2
   TBLPTRH = pAddress.Byte1
   TBLPTRL = pAddress.Byte0
   ASM
   TBLRD*+      
   End ASM
   TBLPTRU = 0
End Function
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Sub memset(pAddress As Word, pValue As Byte, pSize As Word)
   FSR0 = pAddress
   While pSize > 0
      POSTINC0 = pValue
      Dec(pSize)
   Wend
End Sub
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Function strlen(pStr As Word) As Byte
   FSR0 = pStr
   Result = 0
   While POSTINC0 <> 0
      Inc(Result)
   Wend   
End Function 
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Function strlenpgm(pStr As TROMAddress) As Word
   Result = 0
   While ReadROM(pStr) <> 0
      Inc(Result)
      Inc(pStr)
   Wend   
End Function
(*
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
*)
Public Function strequal(ByRef a() As Byte, ByRef b() As Byte) As Boolean
   Dim Index As Byte
   result = true
   FSR0 = @a
   FSR1 = @b
   For index = 0 To Bound(a)
      If POSTINC0 <> POSTINC1 Then
         result = false
         Exit
      EndIf   
   Next
End Function
(*
****************************************************************************
* Name    : Char *strchr( Const Char *str, int ch )                        *
* Purpose : returns a pointer to the first occurence of ch in str, or NULL *
*         : if ch is not found.                                            *
****************************************************************************
*)
Public Function strchr(Str As Word, ch As Byte) As Word
   FSR0 = Str
   While INDF0 <> 0
      If INDF0 = ch Then
         result = Str
         Exit
      EndIf
      Inc(Str)
      FSR0 = Str
   Wend
   result = 0                
End Function
(*
****************************************************************************
* Name    : Char *strchrpgm( Const Char *str, int ch )                     *
* Purpose : returns a pointer to the first occurence of ch in str, or NULL *
*         : if ch is not found.                                            *
****************************************************************************
*)
Public Function strchrpgm(Str As TROMAddress, ch As Byte) As TROMAddress
   Dim Value As Byte
   Value = ReadROM(Str)
   While Value <> 0
      If Value = ch Then
         result = Str
         Exit
      EndIf
      Inc(Str)
      Value = ReadROM(Str)
   Wend
   result = 0 
End Function
(*
****************************************************************************
* Name    : Char * strstrrampgm(Const Char * str, Const rom Char * substr )*
* Purpose : Locate the first occurrence of a string inside another string. *
*         : This function will find the first occurrence of the string     *
*         : substr (excluding the null terminator) within string str.      *
*         : If the string is located, a pointer to that string in str will *
*         : be returned. Otherwise a null pointer is returned.             *
****************************************************************************
*)
Public Function strstrrampgm(pStr As Word, pSubStr As TROMAddress) As Word
   Dim SubStrPos As TROMAddress
   Dim SubChar As Byte

   Result = 0
   SubStrPos = pSubStr
   FSR0 = pStr
   SubChar = ReadROM(SubStrPos)
   While INDF0 <> 0      
      If INDF0 <> SubChar Then
         SubStrPos = pSubStr   
      Else   
         Inc(SubStrPos)
         SubChar = ReadROM(SubStrPos)
         If SubChar = 0 Then
            result = pStr - Word(SubStrPos - pSubStr) + 1
            Exit
         EndIf
      EndIf 
      Inc(pStr)
      FSR0 = pStr
   Wend   
End Function 
(*
****************************************************************************
* Name    : void memcpypgm2ram                                             *
* Purpose : Copy the contents of the source buffer into the destination    *
*         : buffer.                                                        *
****************************************************************************
*)
' djb
Public Sub memcpypgm2ram(dest As Word, source As TROMAddress, Len As Word)
   FSR0 = dest
   While Len > 0
      POSTINC0 = ReadROM(source)
      Inc(source)
      Dec(Len)
   Wend    
End Sub
(*
****************************************************************************
* Name    : memcmppgm2ram                                                  *
* Purpose : Compare the contents of two arrays of bytes.                   *
****************************************************************************
*)
'djb
Public Function memcmppgm2ram(buf1 As Word, buf2 As TROMAddress, Len As Word) As ShortInt
   Dim ValueA, ValueB As Byte
   Result = 0
   While Len > 0 And result = 0
      ValueA = ReadRAM(buf1)
      ValueB = ReadROM(buf2)
      Inc(buf1)
      Inc(buf2)
      Result = ValueA - ValueB
      Dec(Len)
   Wend
End Function
(*
****************************************************************************
* Name    : void strcpypgm2ram                                             *
* Purpose : Copy the contents of the source string into the destination    *
*         : string.                                                        *
****************************************************************************
*)
' djb
Public Sub strcpypgm2ram(dest As Word, source As TROMAddress)
   Dim c As Byte
   c = ReadROM(source)
   While c <> 0
      FSR0 = dest
      INDF0 = c
      Inc(dest)
      Inc(source)
      c = ReadROM(source)
   Wend    
   
   // null terminator
   FSR0 = dest
   INDF0 = 0
End Sub
(*
****************************************************************************
* Name    : strcmppgm2ram                                                  *
* Purpose : Compare the contents of two strings                            *
****************************************************************************
*)
' djb
Public Function strcmppgm2ram(str1 As Word, str2 As TROMAddress) As ShortInt
   Dim ValueA, ValueB As Byte
   Result = 0
   Repeat
      ValueA = ReadRAM(str1)
      ValueB = ReadROM(str2)
      Inc(str1)
      Inc(str2)
      Result = ValueA - ValueB
   Until (Result <> 0) Or (ValueA = 0) Or (ValueB = 0)   
End Function
(*
****************************************************************************
* Name    : strcmp                                                         *
* Purpose : Compare the contents of two strings                            *
****************************************************************************
*)
' djb
Public Function strcmp(str1 As Word, str2 As Word) As ShortInt
   Dim ValueA, ValueB As Byte
   Result = 0
   Repeat
      ValueA = ReadRAM(str1)
      ValueB = ReadRAM(str2)
      Inc(str1)
      Inc(str2)
      Result = ValueA - ValueB
   Until (Result <> 0) Or (ValueA = 0) Or (ValueB = 0)   
End Function
{
****************************************************************************
* Name    : int atoi( const char *str )                                    *
* Purpose : This function converts the ASCII string s into an 16-bit       *
*         : signed integer (-32768 to 32767). The input string must be in  *
*         : base 10 (decimal radix) and can begin with a character         *
*         : indicating sign (+ or -). Overflow results are undefined.  *
****************************************************************************
}
Include "Convert.bas"
Public Function atoi(Str As Word) As Integer
   Dim StrVal As String(7)
   FSR0 = @StrVal
   FSR1 = Str
   While INDF1 <> 0
      POSTINC0 = POSTINC1
   Wend
   INDF0 = 0
   Result = StrToDec(StrVal)
End Function
{
****************************************************************************
* Name    : atol                                                           *
* Purpose : Convert a string into a long integer representation.           *
****************************************************************************
}
' djb
Public Function atol(s As Word) As LongInt   
   Dim str As String(12)
   Dim c As Byte
   
   FSR1 = @Str
   c = ReadRAM(s)
   While s <> 0 
      POSTINC1 = c
      Inc(s)
   Wend
   INDF1 = 0
   result = StrToDec(str)
End Function     
{
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
}
Dim RNDNum As LongWord
(*
Public Function Rand() As RNDNum
   Result = 1664525 * RNDNum + 1013904223
End Function 
*)
Public Function rand() As RNDNum
    Dim Carry As STATUS.Booleans(0)
    RNDNum = RNDNum >> 1
    If Carry Then
       RNDNum = RNDNum Xor $A6A6A6A6
    EndIf
End Function
(*
Dim RandomSeed As Word 
Public Function rand() As RandomSeed
   Dim Rnd As PRODL.AsWord
   Rnd = RandomSeed
   ASM
   movf   Rnd + 1,w
   iorwf  Rnd,w
   btfsc  Rnd, Z  
   incf   Rnd,F
   rlcf   Rnd + 1,w
   xorwf  Rnd + 1,w
   rlcf   WREG,F  
   swapf  Rnd + 1,F
   swapf  Rnd,w
   rlncf  WREG,F 
   xorwf  Rnd + 1,w
   swapf  Rnd + 1,F
   andlw  1
   rlcf   Rnd,F
   xorwf  Rnd,F
   rlcf   Rnd + 1,F
   End ASM 
   RandomSeed = Rnd
End Function
*)
{
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
}
'Public Sub srand(pValue As RandomSeed)
'End Sub 
(*
================================================================================
HELPERS.H
================================================================================
*)
Include "NETTypes.bas"
(*
****************************************************************************
* Name    : swaps                                                          *
* Purpose :                                                                *
****************************************************************************
*)
Public Function swaps(v As Word) As Word
   result.Byte0 = v.Byte1
   result.Byte1 = v.Byte0
End Function
(*
****************************************************************************
* Name    : swapl                                                          *
* Purpose :                                                                *
****************************************************************************
*)
Public Function swapl(v As LongWord) As LongWord
   result.Byte0 = v.Byte3
   result.Byte1 = v.Byte2
   result.Byte2 = v.Byte1
   result.Byte3 = v.Byte0
End Function
(*
****************************************************************************
* Name    : CalcIPChecksum                                                 *
* Purpose :                                                                *
****************************************************************************
*)
Public Function CalcIPChecksum(buffer As Word, count As Word) As Word
   Dim i As Word
   Dim Val As Word
   Dim sum As DWORD_VAL
   
   sum.Val = $00000000
   
   i = count >> 1
   FSR0 = buffer

   // Calculate the sum of all words
   While i <> 0
	  Val.Byte0 = POSTINC0 // 1st byte
	  Val.Byte1 = POSTINC0 // 2nd byte
      sum.Val = sum.Val + Val
      Dec(i)
   Wend
         
   // Add in the sum of the remaining byte, if present
   If count.0 <> 0 Then
      Val.Byte0 = POSTINC0
      Val.Byte1 = 0
      sum.Val = sum.Val + Val
   EndIf
   
   // Do an end-around carry (one's complement arrithmatic)
   sum.Val = sum.w(0) + sum.w(1)

   // Do another end-around carry in case if the prior add 
   // caused a carry out
   sum.w(0) = sum.w(0) + sum.w(1)

   // Return the resulting checksum
   result = Not sum.w(0)
End Function
(*
 *********************************************************************
 * Function:		BOOL StringToIPAddress(BYTE *str, IP_ADDR *IPAddress)
 * PreCondition:	None
 * Input:		    str: Pointer to a dotted decimal IP address string
 *				    IPAddress: Pointer to a location to write the decoded IP 
                    address.  Result is big endian.
 * Output:		    TRUE if a IP address was successfully decoded
 *				    FALSE if no IP address could be found or wrong format
 * Side Effects:	None
 * Overview:		None
 * Note:			None
 ********************************************************************/
*)
Public Function StringToIPAddress(Str As Word, ByRef IPAddress As IP_ADDR) As Boolean
   Dim wNum As Word
   Dim dwVal As	DWORD_VAL
   Dim i, charLen, currentOctet As Byte

   Result = false
   charLen = 0
   currentOctet = 0
   dwVal.Val = 0
   
   FSR1 = Str
   While currentOctet <= 3 And charLen <= 3
         
      i = POSTINC1
      If currentOctet = 3 And charLen > 0 Then
         If i = 0 Or i = Byte("/") Or i = 13 Or i = 10 Or i = Byte(" ") Or i = 9 Then
            Result = true
         EndIf
      EndIf
      
      If i = Byte(".") Or Result Then
         wNum = Word(dwVal.v(2) * 100 + Byte(dwVal.v(1) * 10)) + dwVal.v(0)
         If wNum > 255 Then
            result = false
            Exit
         EndIf   
         IPAddress.v(currentOctet) = wNum.Byte0
		 Inc(currentOctet)
         charLen = 0
		 dwVal.Val = 0
      Else
         i = i - Byte("0")
         If i > 9 Then
            Exit
         EndIf
         
         Inc(charLen)
         dwVal.v(3) = dwVal.v(2)
         dwVal.v(2) = dwVal.v(1)
         dwVal.v(1) = dwVal.v(0)
         dwVal.v(0) = i
      EndIf
   Wend            
End Function
(*
 *********************************************************************
 * Function:		BOOL ROMStringToIPAddress(BYTE *str, IP_ADDR *IPAddress)
 * PreCondition:	None
 * Input:		    str: Pointer to a dotted decimal IP address string
 *				    IPAddress: Pointer to a location to write the decoded IP 
                    address.  Result is big endian.
 * Output:		    TRUE if a IP address was successfully decoded
 *				    FALSE if no IP address could be found or wrong format
 * Side Effects:	None
 * Overview:		None
 * Note:			None
 ********************************************************************/
*)
Public Function ROMStringToIPAddress(Str As TROMAddress, ByRef IPAddress As IP_ADDR) As Boolean
   Dim wNum As Word
   Dim dwVal As	DWORD_VAL
   Dim i, charLen, currentOctet As Byte

   Result = false
   charLen = 0
   currentOctet = 0
   dwVal.Val = 0
   
   While currentOctet <= 3 And charLen <= 3
         
      i = ReadROM(Str)
      Inc(Str)
      If currentOctet = 3 And charLen > 0 Then
         If i = 0 Or i = Byte("/") Or i = 13 Or i = 10 Or i = Byte(" ") Or i = 9 Then
            Result = true
         EndIf
      EndIf
      
      If i = Byte(".") Or Result Then
         wNum = Word(dwVal.v(2) * 100 + Byte(dwVal.v(1) * 10)) + dwVal.v(0)
         If wNum > 255 Then
            result = false
            Exit
         EndIf   
         IPAddress.v(currentOctet) = wNum.Byte0
		 Inc(currentOctet)
         charLen = 0
		 dwVal.Val = 0
      Else
         i = i - Byte("0")
         If i > 9 Then
            Exit
         EndIf
         
         Inc(charLen)
         dwVal.v(3) = dwVal.v(2)
         dwVal.v(2) = dwVal.v(1)
         dwVal.v(1) = dwVal.v(0)
         dwVal.v(0) = i
      EndIf
   Wend            
End Function
(*
 *********************************************************************
 * Function:        WORD Base64Encode(BYTE *cSourceData, WORD wSourceLen, BYTE *cDestData, WORD wDestLen)
 * PreCondition:    None
 * Input:           *cSourceData: Pointer to a string of data to encode
 *					wSourceLen: Length of the data at cSourceData
 * 		            *cDestData: Pointer where to write the Base64 encoded data
 *					wSourceLen: Maximum length that can be written to cDestData.  Base64 encoded data is always at least 25% bigger than the original data.
 * Output:          WORD: Number of bytes written to cDestData.  This 
 *						  will always be a multiple of 4
 * Side Effects:    None
 * Overview:        Performs a Base64 encode on a binary block of data
 * Note:            If cSourceData overlaps with cDestData, the behavior is undefined.
 ********************************************************************/
*)
Public Function Base64Encode(cSourceData As Word, wSourceLen As Word, cDestData As Word, wDestLen As Word) As Word
   Dim i, j As Byte
   Dim vOutput(4) As Byte
   Dim wOutputLen As Word

   wOutputLen = 0
   While wDestLen >= 4 
      // Start out treating the output as all padding
	  vOutput(0) = $FF
	  vOutput(1) = $FF
	  vOutput(2) = $FF
	  vOutput(3) = $FF

      // Get 3 input octets and split them into 4 output hextets (6-bits each) 
	  If wSourceLen = 0 Then
         Break
      EndIf

      FSR0 = cSourceData
      Inc(cSourceData)
      i = INDF0
      
	  Dec(wSourceLen)
      vOutput(0) = (i And $FC) >> 2
	  vOutput(1) = (i And $03) << 4
      If wSourceLen <> 0 Then
         FSR0 = cSourceData
         Inc(cSourceData)
         i = INDF0
		 Dec(wSourceLen)
		 vOutput(1) = vOutput(1) Or ((i And $F0) >> 4)
         vOutput(2) = (i And $0F) << 2
         If wSourceLen <> 0 Then
		    FSR0 = cSourceData
		    Inc(cSourceData)
		    i = INDF0
			Dec(wSourceLen)
			vOutput(2) = vOutput(2) Or ((i And $C0) >> 6)
			vOutput(3) = i And $3F
		 EndIf
      EndIf

      // Convert hextets into Base 64 alphabet and store result
	  For i = 0 To 3
	     j = vOutput(i)

         If j <= 25 Then
            j = j + Byte("A")
         ElseIf j <= 51 Then
		    j = j + (Byte("a") - 26)
         ElseIf j <= 61 Then
            j = j + (Byte("0") - 52)
         ElseIf j = 62 Then
            j = Byte("+")
		 ElseIf j = 63 Then
			j = Byte("/")
		 Else				// Padding
		   j = Byte("=")
         EndIf

         FSR0 = cDestData
         Inc(cDestData)
         INDF0 = j
     Next
	
     // Update counters
	 wDestLen = wDestLen - 4
	 wOutputLen = wOutputLen + 4
   Wend
   result = wOutputLen
End Function
(*
 *********************************************************************
 * Function:        WORD Base64Decode(BYTE *cSourceData, WORD wSourceLen, BYTE *cDestData, WORD wDestLen)
 * PreCondition:    None
 * Input:           *cSourceData: Pointer to a string of Base64 encoded data
 *					wSourceLen: Length of the Base64 data at cSourceData
 * 		            *cDestData: Pointer to write the decoded data
 *					wSourceLen: Maximum length that can be written to cDestData.  Decoded data is always at least 1/4 smaller than Base64 encoded data.
 * Output:          WORD: Number of decoded bytes written to cDestData
 * Side Effects:    None
 * Overview:        Performs a Base64 Decode on an ASCII string
 * Note:            This implementation is binary-safe, and will 
 *					ignore invalid characters (CR, LF, etc).  If 
 *					cSourceData is equal to cDestData, the data will 
 *					be converted in-place.  If cSourceData is not 
 *					equal to cDestData, but the regions overlap, the 
 *					behavior is undefined.
 ********************************************************************/
*)
' djb
Public Function Base64Decode(cSourceData As Word, wSourceLen As Word, cDestData As Word, wDestLen As Word) As Word
   Dim i As Byte
   Dim vByteNumber As Byte
   Dim bPad As Boolean
   Dim wBytesOutput As Word

   vByteNumber = 0
   wBytesOutput = 0

   // Loop over all provided bytes
   While wSourceLen <> 0 
      // Fetch a Base64 byte and decode it to the original 6 bits
	  i = ReadRAM(cSourceData)
      Inc(cSourceData)
      bPad = (i = Byte("="))
      If i >= Byte("A") And i <= Byte("Z") Then	// Regular data
         i = i - (Byte("A") - 0)
	  ElseIf i >= Byte("a") And i <= Byte("z") Then
         i = i - (Byte("a") - 26)
      ElseIf i >= Byte("0") And i <= Byte("9") Then
		 i = i - (Byte("0") - 52)
	  ElseIf i = Byte("+") Or i = Byte("-") Then
         i = 62
      ElseIf i = Byte("/") Or i = Byte("_") Then
         i = 63
      Else 						// Skip all padding (=) and non-Base64 characters
	     Continue
	  EndIf   


      // Write the 6 bits to the correct destination location(s)
      If vByteNumber = 0 Then
         If bPad Then				// Padding here would be illegal, treat it as a non-Base64 chacter and just skip over it
            Continue
		 EndIf
  	     Inc(vByteNumber)
         If wBytesOutput >= wDestLen Then
            Break
         EndIf
         Inc(wBytesOutput)
		 FSR0 = cDestData
         INDF0 = i << 2
      ElseIf vByteNumber = 1 Then
         Inc(vByteNumber)
         FSR0 = cDestData
         Inc(cDestData)
		 INDF0 = INDF0 Or (i >> 4) // *cDestData++ |= i >> 4; ???
         If wBytesOutput >= wDestLen Then
            Break
         EndIf
         If bPad Then
            Continue
         EndIf   
         Inc(wBytesOutput)
         FSR0 = cDestData
		 INDF0 = i << 4
      ElseIf vByteNumber = 2 Then
         Inc(vByteNumber)
         FSR0 = cDestData
         Inc(cDestData)
         INDF0 = INDF0 Or (i >> 2) // *cDestData++ |= i >> 2;
         If wBytesOutput >= wDestLen Then
            Break
         EndIf   
         If bPad Then
            Continue
         EndIf   
         Inc(wBytesOutput)
         FSR0 = cDestData
		 INDF0 = i << 6
      ElseIf vByteNumber = 3 Then
         vByteNumber = 0
         FSR0 = cDestData
		 Inc(cDestData)
         INDF0 = INDF0 Or i //*cDestData++ |= i;
      EndIf
      Dec(wSourceLen)
   Wend
   result = wBytesOutput
End Function
(*
 *********************************************************************
 * Function:        BYTE hexatob(WORD_VAL AsciiChars)
 * PreCondition:    None
 * Input:           Two ascii bytes; each ranged '0'-'9', 'A'-'F', or
 *						'a'-'f'
 * Output:          The resulting packed byte: 0x00-0xFF
 * Side Effects:    None
 * Overview:        None
 * Note:			None
 ********************************************************************/
*)
' djb
Public Function hexatob(AsciiChars As WORD_VAL) As Byte
   // Convert lowercase to uppercase
   If AsciiChars.v(1) > Byte("F") Then
      AsciiChars.v(1) = AsciiChars.v(1) - (Byte("a") - Byte("A"))
   EndIf
   
   If AsciiChars.v(0) > Byte("F") Then
      AsciiChars.v(0) = AsciiChars.v(0) - (Byte("a") - Byte("A"))
   EndIf   

   // Convert 0-9, A-F to 0x0-0xF
   If AsciiChars.v(1) > Byte("9") Then
      AsciiChars.v(1) = AsciiChars.v(1) - (Byte("A") - 10)
   Else
      AsciiChars.v(1) = AsciiChars.v(1) - Byte("0")
   EndIf

   If AsciiChars.v(0) > Byte("9") Then
      AsciiChars.v(0) = AsciiChars.v(0) - (Byte("A") - 10)
   Else
      AsciiChars.v(0) = AsciiChars.v(0) - Byte("0")
   EndIf

   // Concatenate
   result = (AsciiChars.v(1) << 4) Or AsciiChars.v(0)
End Function
(*
 *********************************************************************
 * Function:        BYTE btohexa_high(BYTE b)
 * PreCondition:    None
 * Input:           One byte ranged 0x00-0xFF
 * Output:          An ascii byte (always uppercase) between '0'-'9' 
 *					or 'A'-'F' that corresponds to the upper 4 bits of
 *					the input byte.
 *					ex: b = 0xAE, btohexa_high() returns 'A'
 * Side Effects:    None
 * Overview:        None
 * Note:			None
 ********************************************************************/
*)
' djb
Public Function btohexa_high(b As Byte) As Byte
   b = b >> 4
   If b > $09 Then
      result = b + Byte("A") - 10
   Else
      result = b + Byte("0")
   EndIf
End Function
(*
 *********************************************************************
 * Function:        BYTE btohexa_low(BYTE b)
 * PreCondition:    None
 * Input:           One byte ranged 0x00-0xFF
 * Output:          An ascii byte (always uppercase) between '0'-'9' 
 *					or 'A'-'F' that corresponds to the lower 4 bits of
 *					the input byte.
 *					ex: b = 0xAE, btohexa_low() returns 'E'
 * Side Effects:    None
 * Overview:        None
 * Note:			None
 ********************************************************************/
*)
' djb
Public Function btohexa_low(b As Byte) As Byte
   b = b And $0F
   If b > $09 Then
      result = b + Byte("A") - 10
   Else
      result = b + Byte("0")
   EndIf
End Function
(*
 *********************************************************************
 * Function:        signed char stricmppgm2ram(BYTE* a, ROM BYTE* b)
 * PreCondition:    None
 * Input:           a: pointer to a string
 *					b: pointer to a string stored in program memory
 * Output:          0 if a = b
 *					1 if a > b
 *					-1 if a < b
 * Side Effects:    None
 * Overview:        Performs a case-insensitive comparison of two 
 *					strings.
 * Note:			None
 ********************************************************************/
*)
' djb
Public Function stricmppgm2ram(a As Word, b As TROMAddress) As ShortInt
   Dim cA, cB As Byte
	
   // Load first two characters
   cA = ReadRAM(a)
   cB = ReadROM(b)
	
   // Loop until one string terminates
   While cA <> 0 And cB <> 0
      // Shift case if necessary
	  If cA >= Byte("a") And cA <= Byte("z") Then
         cA = cA - (Byte("a") - Byte("A"))
      EndIf

      If cB >= Byte("a") And cB <= Byte("z") Then
         cB = cB - (Byte("a") - Byte("A"))
      EndIf
			
      // Compare
	  If cA > cB Then
         result = 1
         Exit
      EndIf
      If cA < cB Then
         result = -1
         Exit
      EndIf
		
      // Characters matched, so continue
	  Inc(a)
      Inc(b)
      cA = ReadRAM(a)
      cB = ReadROM(b)
   Wend
	
   // See if one string terminated first
   If cA > cB Then
      result = 1
      Exit
   EndIf
      
   If cA < cB Then
      result = -1
      Exit
   EndIf

   // Strings match
   result = 0
End Function

// initialise
RNDNum = $0345

  
