{
*****************************************************************************
*  Name    : NETDisplay.BAS                                                 *
*  Author  : David John Barker                                              *
*  Notice  : Copyright (c) 2007 Mecanique                                   *
*          : All Rights Reserved                                            *
*  Date    : 09/10/2007                                                     *
*  Version : 1.0                                                            *
*  Notes   :                                                                *
*          :                                                                *
*****************************************************************************
}
Module NETDisplay

Include "NETConfig.bas"
Include "NETTypes.bas"
Include "usart.bas"
Include "convert.bas"
{
****************************************************************************
* Name    : DisplayIPAddress                                               *
* Purpose :                                                                *
****************************************************************************
}
Public Sub DisplayIPAddress(ByRef pAddr As IP_ADDR)
   Dim Index As Byte
   For index = 0 To 3
      Write(DecToStr(pAddr.v(Index)))
      If Index <> 3 Then
         Write(".")
      EndIf
   Next
   Write(13,10)
End Sub
{
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
}
Public Sub DisplayHostName()
   Dim Index As Byte
   Index = 0
   Repeat
      Write(AppConfig.NetBIOSName(Index))
      Inc(Index)
   Until AppConfig.NetBIOSName(Index) = 0
   Write(13,10)      
End Sub
{
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
}
Public Sub DisplayMACAddress()
   Dim Index As Byte
   For Index = 0 To 5
      Write("$",HexToStr(AppConfig.MyMACAddr.v(Index),2)," ")
   Next   
   Write(13,10)
End Sub
{
****************************************************************************
* Name    :                                                                *
* Purpose :                                                                *
****************************************************************************
}
Public Sub DisplayConfig()
   #if defined(STACK_USE_NBNS)
   Write("Host Name     : ")
   DisplayHostName
   #endif
   
   Write("MAC Address   : ")
   DisplayMACAddress
   Write("IP address    : ")
   DisplayIPAddress(AppConfig.MyIPAddr)
   Write("Mask          : ")
   DisplayIPAddress(AppConfig.MyMask)
   Write("Gateway       : ")
   DisplayIPAddress(AppConfig.MyGateway)
   
   #if defined(STACK_USE_DNS)
   Write("Primary DNS   : ")
   DisplayIPAddress(AppConfig.PrimaryDNSServer)
   Write("Secondary DNS : ")
   DisplayIPAddress(AppConfig.SecondaryDNSServer)
   #endif
End Sub

