{
*****************************************************************************
*  Name    : UTC.bas                                                        *
*  Author  : Gabi Mihail and Timothy Box                                    *
*  Notice  : Copyright (c) 2007 Mecanique                                   *
*          : All Rights Reserved                                            *
*  Date    : 18/09/2007                                                     *
*  Version : 1.0                                                            *
*  Notes   :                                                                *
*          :                                                                *
*****************************************************************************
}
Module UTC

Public Structure TDateTime
   Sec As Byte
   Min As Byte
   Hour As Byte
   Year As Word 
   Month As Byte
   Day As Byte
   DOW As Byte
End Structure 

Public Const
   DayOfWeek(7) As String = ("Thu","Fri","Sat","Sun","Mon","Tue","Wed")
Public Dim 
   DateTime As TDateTime
{
****************************************************************************
* Name    : Decode                                                         *
* Purpose : http://www.onlineconversion.com/unix_time.htm                  *
*         : DayOfWeek 0 = Thu, 1 = Fri ... 6 = Wed                         *                                 
****************************************************************************
}
Public Sub Decode(pUTC As LongWord) 
   Const CMonthsDays(13) As Byte = (0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
   Dim TempDay As LongWord
   Dim tempa As LongWord
   
   // seconds...
   DateTime.Sec = pUTC Mod 60
   pUTC = pUTC / 60

   // minutes...
   DateTime.Min = pUTC Mod 60
   pUTC = pUTC / 60

   // hours...
   DateTime.Hour = pUTC Mod 24
   pUTC = pUTC / 24

   // here pUTC equals number of days since Thu 1st Jan 1970 
   DateTime.DOW = pUTC Mod 7 
   
   // we start with the NTP starting year offset 
   DateTime.Year = 1970         
   While true
      TempDay = 365              //  say its a normal year (not leap)
      If (DateTime.Year And $03) = 0 Then
         TempDay = 365 + 1      // LEAP Year
      EndIf    
      If TempDay > pUTC Then
         Break 
      EndIf
	  pUTC = pUTC - TempDay 
      Inc(DateTime.Year)
   Wend

   // month...
   For DateTime.Month = 1 To 12                            
      tempa = CMonthsDays(DateTime.Month)
      If pUTC <= tempa Then
         Break
      EndIf
      pUTC = pUTC - tempa   
   Next

   // days... 
   If TempDay = 366 And DateTime.Month <= 2 Then
      DateTime.Day = pUTC + 1
      Exit 
   ElseIf TempDay = 366 And DateTime.Month > 2 Then
      DateTime.Day = pUTC
      Exit 
   EndIf
   If TempDay = 365 And DateTime.Month = 2 Then
      DateTime.Day = pUTC + 1 
      If DateTime.Day = 29 Then
         DateTime.Day = 1
         DateTime.Month = DateTime.Month + 1
      EndIf
      Exit 
   EndIf
   DateTime.Day = pUTC + 1
End Sub

