// basic platform hdw test
program BasicTest

//
//-----------------------------------------------------------------------------
// hardware platforms (uncomment one section/customize for your hardware)
// the USER_INIT file for each platform contains the pic config settings, 
// userInit() routine, LED definitions, and any misc setup info
//-----------------------------------------------------------------------------
//
'{
// LJCV Electronics eIP-10 18F2620 with ENC28J60 (http://www.ljcv.net/eip10/)
device = 18F2620
clock = 40
#option USER_INIT = "EIP10_2620.bas"
#option ETH_MAC = ENC28J60
'}

{
// Microchip explorer18 (18F8722) with pictail plus (ETH_MAC = ENCx24J600)
device = 18F8722
clock = 32
#option USER_INIT = "EXP18_8722.bas"
#option ETH_MAC = ENCx24J600
}

{
// Microchip explorer18 with 18F87K22 PIM and pictail plus (ETH_MAC = ENCx24J600)
device = 18F87K22
clock = 64
#option USER_INIT = "EXP18_87K22.bas"
#option ETH_MAC = ENCx24J600
}

{
// Olimex PIC-WEB board 18F67J60 (https://www.olimex.com/Products/PIC/Development/PIC-WEB/)
device = 18F67J60
// select clock - either 25MHz or 41.6667MHz
'clock = 25      // default
clock = 41.6667    // 5xPLL=enabled, PLL Prescaler=div3, PLL Postscaler=disabled
#option USER_INIT = "PIC_WEB_67J60.bas"
'#option ETH_MAC = ETHXXJ60
}

// test network TICK function (TMR0+interrupt)
#option TICK_TEST = true

//
//-----------------------------------------------------------------------------
// hardware setup
//-----------------------------------------------------------------------------
//
// include the board support USER_INIT file specified above
// if '#option USER_AUTO_INIT=true' then userInit() will be called automatically
// by the module to setup the clock and IO
'#option USER_AUTO_INIT=true
include USER_INIT

// USART support
#option USART_BRGH = true
#option USART_BRG16 = true
include "usart.bas"

// net TICK (TMR0 interrupt)
#if (TICK_TEST)
#option NET_TICK_PRIORITY = ipHigh       
include "tick.bas"
dim start_time as TICK
#endif

// program start...
// uncomment this to run the uC clock check loop
'userClockCheck()

usart.SetBaudrate(br115200)
usart.Write(13, 10, "hello...", 13, 10)

#if (TICK_TEST)
TickInit()
#endif

while (true)
    toggle(LED1)            // LED should blink twice a second
    // echo test for usart
    if (usart.DataAvailable) then
        usart.writebyte(usart.readbyte())
    endif
  #if (TICK_TEST)           // check tick timer
    start_time = TickGet()
    while ((TickGet() - start_time) < 250)   // wait 250ms
    end while
  #else
    delayms(250)
  #endif
    usart.ClearOverrun()    // just in case since we delayed so long...
end while

end program
